#!/usr/bin/python

import zlib

seq = ("Blc","Vi","Blc","Vi","Bl","Vi","R","Bl","N","R", "Bl","Blc","Blanc","J","Bl","R","N","Vi","Blanc","V","J","N","R","J","Blc","Blanc","N","Blc","N","V","Blanc","J", "Bl", "J", "Bl", "Vi", "Bl", "Vi", "N", "Blanc","Bl", "Blc", "Bl", "V", "Bl", "Blanc","Bl", "Blanc", "R","Blanc", "V", "Blc", "R", "J", "Blc", "V", "Bl", "R", "V", "Blc", "R","J","Vi","Blanc","V","Vi","Blc","J","Blanc","N","R","Blc", "Blanc", "N", "Blc","N","Bl","R","Blanc","Vi","N","V","R","Vi")

color_off = 6

colors = ["R","V","J","Bl","Vi","Blc","Blanc","N"]

key = "2830a43f6d280423362a32dcad0ba04be8201f64840af4c4c78a8dc0a2".decode("hex")

out = ""
for k in xrange(0, len(seq), 3):
    v1 = colors.index(seq[k])
    v2 = colors.index(seq[k+1])
    v3 = colors.index(seq[k+2])

    o1 = (v1 - color_off - 1) % 8
    o2 = (v2 - v1 - 1) % 8
    o3 = (v3 - v2 - 1) % 8

    color_off = v3

    value = ((o3*7) + o2)*7 + o1

    out += chr(value&0xff)

res = ''.join(chr((ord(out[k])^ord(key[k]))&0xff) for k in xrange(len(out)))
#print res.encode("hex")

res = zlib.decompress(res[4:])
print res.encode("hex")
